from bcdebug import debug
import App

# types for initializing objects create from C.
UNKNOWN			= 0
EXCALIBUR		= 1
SOVEREIGN		= 2
USSLENNOX		= 3
MVAMPROMETHEUS		= 4
GALAXY			= 5
EXIMIUS                 = 6
AKIRA			= 7
NEBULA			= 8
PHOENIX                 = 9
LAKOTA			= 10
LCAMBASSADOR            = 11
GALAXYSAUCER            = 12
GALAXYSTARDRIVE         = 13
EXCELSIOR               = 14
INTREPID		= 15
DEFIANT			= 16
STEAMRUNNER		= 17
CENTAUR                 = 18
CHEYENNE                = 19
MVAMPROMETHEUSDORSAL	= 20
MVAMPROMETHEUSSAUCER	= 21
MVAMPROMETHEUSVENRAL	= 22
NORWAY			= 23
CONSTITUTION            = 24
MIRANDA                 = 25
NOVAII			= 26
NOVA			= 27
SABRE                   = 28
AEGIAN			= 29
DELTAFLYER		= 30
PERAGRINEF1		= 31
DANUBEMKI		= 32
DANUBEMKII		= 33
TYPE9                   = 34
TYPE11                  = 35
VENTURESCOUT            = 36
SOVEREIGNYACHT          = 37
SOVEREIGNYACHTWARP      = 38
SHUTTLE			= 39
FREIGHTER		= 40
TRANSPORT		= 41
MIRANDAPOD		= 42
FEDCONST		= 43
FEDCONSTOPEN		= 44
MPNEGHVAR		= 45
FEKLHRMK2               = 46
VORCHA			= 47
KTINGA                  = 48
KVORT                   = 49
BIRDOFPREY		= 50
CLOAKFIREBIRDOFPREY     = 51
KLINGONSHUTTLE          = 52
SCIMITAR		= 53
WARBIRD			= 54
VALDORE			= 55
LCRAPTOR                = 56
FIREHAWK                = 57
VENATOR                 = 58
PRAETOR                 = 59
SHRIKE                  = 60
GRIFFIN                 = 61
VASKHOLHR		= 62
FALCON                  = 63
ROMULANSHUTTLE          = 64
HUTET			= 65
DOMBB			= 66
KELDON			= 67
DOMBC			= 68
CARDHYBRID		= 69
GALOR			= 70
KESSOKHEAVY		= 71
KESSOKLIGHT		= 72
BREEN                   = 73
HIDEKI			= 74
BUG			= 75
CARDFREIGHTER		= 76
KAREMMA                 = 77
SPHERE                  = 78
BORGDIAMOND             = 79
SONAB                   = 80
CA8472                  = 81
MARAUDER		= 82
MIRADORN                = 83
KAZONRAIDER		= 84
JUNK                    = 85
WORKERBEE               = 86
MERCHANTMAN             = 87
ROMULANOUTPOST	        = 88
SPACEFACILITY		= 89
COMMARRAY		= 90
COMMLIGHT		= 91
DRYDOCK			= 92
PROBE			= 93
DECOY			= 94
SUNBUSTER		= 95
CARDOUTPOST		= 96
CARDSTARBASE		= 97
CARDSTATION		= 98
FEDOUTPOST		= 99
FEDSTARBASE		= 100
ASTEROID		= 101
ASTEROID1		= 102
ASTEROID2		= 103
ASTEROID3		= 104
AMAGON			= 105
BIRANUSTATION		= 106
ENTERPRISE		= 107
GERONIMO		= 108
PEREGRINE		= 109
ASTEROIDH1		= 110
ASTEROIDH2		= 111
ASTEROIDH3		= 112
ESCAPEPOD		= 113
CARDPOD 		= 114
DEFPOD  		= 115
GALPOD  		= 116
GREENPOD                = 117
KESSOKMINE		= 118
LOWCUBE			= 119
DS9			= 120
MINE                    = 121
CITY                    = 122
STARBASE220             = 123
FIREPOINT               = 124
BIGFIREPOINT            = 125
DRYDOCKREPAIR           = 126
HIDDENCORE              = 127
IMPERIALBASE            = 128
STARBASE329		= 129
VAS_PORT_WING		= 130
VAS_STARPORT_WING	= 131
COWP			= 132
COWPASTEROID		= 133
PULSEMINE		= 134
TORPEDOMINE		= 135
INTREPID_N_LEFT		= 136
INTREPID_N_RIGHT	= 137
BLACKHOLE		= 138

MAX_SHIPS = 140
MAX_FLYABLE_SHIPS = 87

# Setup tuples
kSpeciesTuple = (
	(None, 0, "Neutral", 0),
	("DyExcalibur",	138, "Federation", 1),
	("Sovereign" , App.SPECIES_SOVEREIGN, "Federation", 1),
	("USSLennox",	128, "Federation", 1),
	("MvamPrometheus" , 113, "Federation", 1),
	("Galaxy", App.SPECIES_GALAXY, "Federation", 1),
	("Eximius",	143, "Federation", 1),
	("Akira", App.SPECIES_AKIRA, "Federation", 1),
	("Nebula" , App.SPECIES_NEBULA, "Federation", 1),
	("Phoenix",	132, "Federation", 1),
	("PsExcelsiorRefitTNG1" , 110, "Federation", 1),
	("Ambassador", App.SPECIES_AMBASSADOR, "Federation", 1),
	("GalaxySaucer" , 125, "Federation", 1),
        ("GalaxyStardrive" , 126, "Federation", 1),
	("ExcelsiorP81" , 129, "Federation", 1),
	("LCIntrepid",	114, "Federation", 1),
	("Defiant",	136, "Federation", 1),
	("Steamrunner",	120, "Federation", 1),
	("LCCentaur",   144, "Federation", 1),
	("Cheyenne",	131, "Federation", 1),
	("MvamPrometheusDorsal" , 121, "Federation", 1),
        ("MvamPrometheusSaucer" , 122, "Federation", 1),
        ("MvamPrometheusVentral" , 123, "Federation", 1),
	("norway",	116, "Federation", 1),
	("EnterpriseNCC1701",   148, "Federation", 1),
	("Miranda",   147, "Federation", 1),
	("novaII",	118, "Federation", 1),
	("Nova",	117, "Federation", 1),
	("Sabre",	130, "Federation", 1),
	("Aegian",	109, "Federation", 1),
	("deltaflyer",	112, "Federation", 1),
	("PeragrineF1",	119, "Federation", 1),
	("DanubemkI",	111, "Federation", 1),
        ("DanubemkII",	127, "Federation", 1),
	("type9",	133, "Federation", 1),
        ("Type11",	146, "Federation", 1),
        ("VentureScout",	139, "Federation", 1),
	("sovereignyacht",	134, "Federation", 1),
        ("sovereignyachtwarp",	135, "Federation", 1),
	("Shuttle" , App.SPECIES_SHUTTLE, "Federation", 1),
	("Freighter" , App.SPECIES_FREIGHTER, "Federation", 1),
	("Transport" , App.SPECIES_TRANSPORT, "Federation", 1),
	("ZZSaratogaPod2", 150, "Federation", 1),
	("FedConst",	140, "Federation", 1),
	("FedConstOpen",	141, "Federation", 1),
	("MPneghvar",	403, "Klingon", 1),
	("FeklhrMK2",	406, "Klingon", 1),
	("Vorcha" , App.SPECIES_VORCHA, "Klingon", 1),
	("KTinga",	407, "Klingon", 1),
	("Kvort",	404, "Klingon", 1),
	("BirdOfPrey", App.SPECIES_BIRD_OF_PREY, "Klingon", 1),
	("CloakFireBirdOfPrey",	App.SPECIES_BIRD_OF_PREY, "Klingon", 1),
	("KlingonShuttle", 405, "Klingon", 1),
	("Reman Scimitar" , 718, "Romulan", 1),
	("Warbird" , App.SPECIES_WARBIRD, "Romulan", 1),
	("ValdoreG",	302, "Romulan", 1),
	("LCRaptor",	309, "Romulan", 1),
	("Firehawk",	308, "Romulan", 1),
	("venator",	307, "Romulan", 1),
	("Praetor",	305, "Romulan", 1),
	("Shrike",	306, "Romulan", 1),
	("griffin",	303, "Romulan", 1),
	("VasKholhr", 311, "Romulan", 1),
	("Falcon",	304, "Romulan", 1),
	("romulanshuttle", 310, "Romulan", 1),
	("Hutet", 205, "Dominion Axis", 1),
	("DomBB" , 901, "Dominion Axis", 1),
	("Keldon" , App.SPECIES_KELDON, "Dominion Axis", 1),
	("DomBC" , 902, "Dominion Axis", 1),
	("CardHybrid", App.SPECIES_CARDHYBRID, "Dominion Axis", 1),
	("Galor" , App.SPECIES_GALOR, "Dominion Axis", 1),
	("KessokHeavy" , App.SPECIES_KESSOK_HEAVY, "Dominion Axis", 1),
	("KessokLight" , App.SPECIES_KESSOK_LIGHT, "Dominion Axis", 1),
	("Breen", 717, "Dominion Axis", 1),
	("Hideki", 206, "Dominion Axis", 1),
	("bug",		923, "Dominion Axis", 1),
	("CardFreighter", App.SPECIES_CARDFREIGHTER, "Dominion Axis", 1),
	("Karemman", 925, "Dominion Axis", 1),
	("sphere" , 721, "Borg", 1),
	("BorgDiamond" , 720, "Borg", 1),
	("SonaB",	920, "Other", 1),
	("CA8472" , 903, "Other", 1),
	("Marauder" , App.SPECIES_MARAUDER, "Other", 1),
	("Miradorn", 922, "Other", 1),
	("Kazonraider",	915, "Other", 1),
	("Junk",	918, "Other", 1),
	("WorkerBee",	919, "Other", 1),  
	("Merchantman", 924, "Other", 1),
	("RomulanOutpost", 716, "Romulan", 1),
        ("SpaceFacility" , App.SPECIES_SPACE_FACILITY, "Federation", 1),
	("CommArray" , App.SPECIES_COMMARRAY, "Federation", 1),
	("CommLight", App.SPECIES_COMMLIGHT, "Cardassian", 1),
	("DryDock" , App.SPECIES_DRYDOCK, "Federation", 1),
	("Probe" , App.SPECIES_PROBE, "Federation", 1),
	("Decoy" , App.SPECIES_PROBETYPE2, "Federation", 1),
	("Sunbuster" , App.SPECIES_SUNBUSTER, "Kessok", 1),
	("CardOutpost" , App.SPECIES_CARD_OUTPOST, "Cardassian", 1),
	("CardStarbase" , App.SPECIES_CARD_STARBASE, "Cardassian", 1),
	("CardStation" , App.SPECIES_CARD_STATION, "Cardassian", 1),
	("FedOutpost" , App.SPECIES_FED_OUTPOST, "Federation", 1),
	("FedStarbase" , App.SPECIES_FED_STARBASE, "Federation", 1),
	("Asteroid" , App.SPECIES_ASTEROID, "Neutral", 1),
	("Asteroid1" , App.SPECIES_ASTEROID, "Neutral", 1),
	("Asteroid2" , App.SPECIES_ASTEROID, "Neutral", 1),
	("Asteroid3" , App.SPECIES_ASTEROID, "Neutral", 1),
	("Amagon", App.SPECIES_ASTEROID, "Cardassian", 1),
	("BiranuStation", App.SPECIES_SPACE_FACILITY, "Neutral", 1),
	("Enterprise", App.SPECIES_SOVEREIGN, "Federation", 1),
	("Geronimo", App.SPECIES_AKIRA, "Federation", 1),
	("Peregrine", App.SPECIES_NEBULA, "Federation", 1),
	("Asteroidh1" , App.SPECIES_ASTEROID, "Neutral", 1),
	("Asteroidh2" , App.SPECIES_ASTEROID, "Neutral", 1),
	("Asteroidh3" , App.SPECIES_ASTEROID, "Neutral", 1),
	("Escapepod" , App.SPECIES_ESCAPEPOD, "Neutral", 1),
        ("card pod" , App.SPECIES_ESCAPEPOD, "Neutral", 1),
        ("defpod" , App.SPECIES_ESCAPEPOD, "Neutral", 1),
        ("Galaxy Escape Pod" , App.SPECIES_ESCAPEPOD, "Neutral", 1),
        ("greenmisc" , App.SPECIES_ESCAPEPOD, "Neutral", 1),
	("KessokMine" , App.SPECIES_KESSOKMINE, "Kessok", 1),
	("LowCube" , App.SPECIES_BORG, "Borg", 1),
	("ds9" , 137, "Federation", 1),
        ("Mine" , 155, "Federation", 1),
        ("City", 917, "Neutral", 1),
        ("Starbase220", 145, "Federation", 1),
        ("Firepoint", App.SPECIES_PROBE, "Other", 1),
        ("BigFirepoint", App.SPECIES_PROBE, "Other", 1),
        ("DryDockRepair", App.SPECIES_DRYDOCK, "Federation", 1),
        ("HiddenCore",	921, "Other", 1),
        ("KlingonImperialStarbase", 408, "Klingon", 1),
	("StarBase329", 149, "Federation", 1),
	("VasKholhr_PortWing", 312, "Romulan", 1),
	("VasKholhr_Starboardwing", 313, "Romulan", 1),
	("cOWP", 207, "Cardassian", 1),
	("CowpAsteroid", 208, "Cardassian", 1),
	("pulsemine", 151, "Federation", 1),
	("torpedomine", 152, "Federation", 1),
	("LCIntrepid_n_left", 153, "Federation", 1),
	("LCIntrepid_n_right", 154, "Federation", 1),
	("blackhole", 926, "Other", 1),
	
	(None, 0, "Neutral", 1))
	
def GetShipFromSpecies(iSpecies):
    debug(__name__ + ", GetShipFromSpecies")
    # fix signed stuff
    if iSpecies < 0:
	    iSpecies = iSpecies + 256
    debug(__name__ + ", GetShipFromSpecies num %d" % iSpecies)
    if ((iSpecies <= 0) or (iSpecies >= MAX_SHIPS)):
	debug(__name__ + ", GetShipFromSpecies return None")
        return None
    pSpecTuple = kSpeciesTuple[iSpecies]
    pcScript = pSpecTuple[0]
    debug(__name__ + ", GetShipFromSpecies Loading %s" % pcScript)
    ShipScript = __import__(('ships.' + pcScript))
    ShipScript.LoadModel()
    return ShipScript.GetShipStats()


def GetScriptFromSpecies(iSpecies):
    debug(__name__ + ", GetScriptFromSpecies")
    if ((iSpecies <= 0) or (iSpecies >= MAX_SHIPS)):
        return None
    pSpecTuple = kSpeciesTuple[iSpecies]
    return pSpecTuple[0]


def InitObject(self, iType):
        debug(__name__ + ", InitObject")
        kStats = GetShipFromSpecies(iType)
	debug(__name__ + ", InitObject: GetShipFromSpecies Done")
        if (kStats == None):
		debug(__name__ + ", InitObject bye")
                return 0
        self.SetupModel(kStats['Name'])
	debug(__name__ + ", InitObject: SetupModel Done")
	sShipScript = GetScriptFromSpecies(iType)
	if sShipScript:
		self.SetScript('ships.' + sShipScript)
        pPropertySet = self.GetPropertySet()
        if kStats.has_key("NormalHP"):
                mod = __import__(('ships.Hardpoints.' + kStats["NormalHP"]))
        else:
                mod = __import__(('ships.Hardpoints.' + kStats['HardpointFile']))
        App.g_kModelPropertyManager.ClearLocalTemplates()
        reload(mod)
        mod.LoadPropertySet(pPropertySet)
	debug(__name__ + ", SetupProperties")
        self.SetupProperties()
        self.UpdateNodeOnly()
	debug(__name__ + ", InitObject End")
        return 1


def CreateShip(iType):
        debug(__name__ + ", CreateShip")
        kStats = GetShipFromSpecies(iType)
        if (kStats == None):
                return None
        pShip = App.ShipClass_Create(kStats['Name'])
        sModule = ('ships.' + kSpeciesTuple[iType][0])
        pShip.SetScript(sModule)
        pPropertySet = pShip.GetPropertySet()
        mod = __import__(('ships.Hardpoints.' + kStats['HardpointFile']))
        App.g_kModelPropertyManager.ClearLocalTemplates()
        reload(mod)
        mod.LoadPropertySet(pPropertySet)
        pShip.SetupProperties()
        pShip.UpdateNodeOnly()
        pShip.SetNetType(iType)
        return pShip


def GetIconNum(iSpecies):
    debug(__name__ + ", GetIconNum")
    pSpecTuple = kSpeciesTuple[iSpecies]
    iNum = pSpecTuple[1]
    return iNum


def GetSideFromSpecies(iSpecies):
    debug(__name__ + ", GetSideFromSpecies")
    pSpecTuple = kSpeciesTuple[iSpecies]
    pcSide = pSpecTuple[2]
    return pcSide


def GetClassFromSpecies(iSpecies):
    debug(__name__ + ", GetClassFromSpecies")
    pSpecTuple = kSpeciesTuple[iSpecies]
    iClass = pSpecTuple[3]
    return iClass

